if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.ArgusPets = {}
local this = ttd2.ArgusPets
this.Name = "ArgusPets"

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.Pets =
	{
		{ ItemID = 153195, SpeciesID = 2136, src = { MapID = 885, x = 0.547, y = 0.391, FlagQuest = 48966, WQuest = nil, Name = "Verschlinger", preQuest = 48870, extraInfo = "always up" } },
		{ ItemID = 153252, SpeciesID = 2135, src = { MapID = 885, x = 0.655, y = 0.266, FlagQuest = 48970, WQuest = nil, Name = "Rosula", requItem = 152999, extraInfo = "always up" } },
		{ ItemID = 153056, SpeciesID = 2120, src = { MapID = 882, x = 0.303, y = 0.404, FlagQuest = 48709, WQuest = 48729, Name = "Ataxon" } }
	}
	
	for _, Pet in pairs(this.private.Pets) do
		lib.item.AddByID(Pet.ItemID)
		lib.journal.pet.AddByID(Pet.SpeciesID)
		lib.quest.AddByID(Pet.src.FlagQuest)
		
		if(Pet.src.requItem ~= nil) then
			lib.item.AddByID(Pet.src.requItem)
		end
		
		if(Pet.src.preQuest ~= nil) then
			lib.quest.AddByID(Pet.src.preQuest)
		end
	end
	
	return
end

function this.Update()
	this.private.Validate()
	
	for _, Pet in pairs(this.private.Pets) do
		lib.item.UpdateByID(Pet.ItemID)
		lib.journal.pet.UpdateByID(Pet.SpeciesID)
		lib.quest.UpdateByID(Pet.src.FlagQuest)
		
		if(Pet.src.requItem ~= nil) then
			lib.item.UpdateByID(Pet.src.requItem)
		end
		
		if(Pet.src.preQuest ~= nil) then
			lib.quest.UpdateByID(Pet.src.preQuest)
		end
		
		Pet.src.Name = lib.journal.pet.GetByID(Pet.SpeciesID).Source
	end
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	for _, Pet in pairs(this.private.Pets) do
		local PetData = lib.journal.pet.GetByID(Pet.SpeciesID)
		
		if(lib.quest.GetByID(Pet.src.FlagQuest).isCompleted == true) then
			out.StoreDone(lib.item.GetByID(Pet.ItemID).Link)
		else
			--start message with item link
			local msg = lib.item.GetByID(Pet.ItemID).Link
			
			--add x/y for pets you already have
			if(PetData.isCollected == true) then
				msg = msg.." ("..PetData.NumCollected.." / "..PetData.NumLimit..")"
			end
			
			--now add the tomtom link
			msg = msg..lib.tomtom.createLink(Pet.src.MapID, Pet.src.x, Pet.src.y, Pet.src.Name)
			
			if(Pet.src.extraInfo ~= nil) then
				msg = msg.." ("..Pet.src.extraInfo..")"
			end
			
			if(Pet.src.requItem ~= nil) then
				msg = msg.." (requires "..lib.item.GetByID(Pet.src.requItem).Link..")"
			end
			
			if(Pet.src.preQuest ~= nil and (not lib.quest.GetByID(Pet.src.preQuest).isCompleted)) then
				msg = msg.." (requires "..lib.quest.GetByID(Pet.src.preQuest).Link..")"
			end
			
			--now add the WQ note
			if(Pet.src.WQuest ~= nil) then
				if(lib.worldquest.IsActive(Pet.src.WQuest)) then
					msg = msg..lib.chat.yellow(" WQ active")
				else
					msg = msg..lib.chat.red(" WQ not active")
				end
			end
			
			--now decide the symbol and print the message
			if(PetData.isCollected == true) then
				out.StoreCompleted(msg)
			else
				out.StoreTodo(msg)
			end
		end
	end
	
	return
end

function this.Print()
	this.private.Validate()
	
	local out = lib.chat.output
	out.PrintModule(this.Name)
	
	return
end

this.private.Text = this.Name
function this.private.Script()
	this.private.Validate()
	
	this.Update()
	this.Print()
	
	return
end

mod[#mod+1] =
{
	Text = this.private.Text,
	Script = this.private.Script
}
