if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.ArgusToys = {}
local this = ttd2.ArgusToys
this.Name = "ArgusToys"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.Toys =
	{
		{ ItemID = 153126, src = { MapID = 885, x = 0.619, y = 0.643, FlagQuest = 48814, WQuest = 48829, name = "Yarez" } },
		{ ItemID = 153253, src = { MapID = 885, x = 0.774, y = 0.749, FlagQuest = 48967, WQuest = nil, name = "Vishax", preQuest = 49007 } },
		{ ItemID = 153194, src = { MapID = 885, x = 0.586, y = 0.118, FlagQuest = 48968, WQuest = nil, name = "Suprax", extraInfo = "requires 3 players to summon" } },				
		{ ItemID = 153293, src = { MapID = 885, x = 0.650, y = 0.826, FlagQuest = 48971, WQuest = nil, name = "Rezira", requItem = 153226 } },
		{ ItemID = 153124, src = { MapID = 830, x = 0.534, y = 0.309, FlagQuest = 48565, WQuest = 48512, name = "Subversia" } },
		
		{ ItemID = 153183, src = { MapID = 882, x = 0.363, y = 0.236, FlagQuest = 48703, WQuest = 48723, name = "Thanos" } },
		{ ItemID = 153183, src = { MapID = 882, x = 0.638, y = 0.646, FlagQuest = 48704, WQuest = 48724, name = "Kuro" } },
		
		{ ItemID = 153179, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, name = "Tarahna" } },
		{ ItemID = 153180, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, name = "Tarahna" } },
		{ ItemID = 153181, src = { MapID = 882, x = 0.614, y = 0.502, FlagQuest = 48718, WQuest = 48737, name = "Tarahna" } },
		{ ItemID = 153193, src = { MapID = 882, x = 0.438, y = 0.602, FlagQuest = 48700, WQuest = 48701, name = "Baruut" } }
	}
	
	local Toys = this.private.Toys
	for _,Toy in pairs(Toys) do
		lib.item.AddByID(Toy.ItemID)
		lib.journal.toy.AddByID(Toy.ItemID)
		lib.quest.AddByID(Toy.src.FlagQuest)
		if(Toy.src.preQuest ~= nil) then
			lib.quest.AddByID(Toy.src.preQuest)
		end
		if(Toy.src.requItem ~= nil) then
			lib.item.AddByID(Toy.src.requItem)
		end
		if(Toy.src.WQuest ~= nil) then
			Toy.src.Name = lib.worldquest.GetNameByID(Toy.src.WQuest)
		end
	end
	
	this.private.set = true
end

function this.private.Update()
	this.private.Validate()
	
	local Toys = this.private.Toys
	
	for _,Toy in pairs(Toys) do
		lib.item.UpdateByID(Toy.ItemID)
		lib.journal.toy.UpdateByID(Toy.ItemID)
		lib.quest.UpdateByID(Toy.src.FlagQuest)
		if(Toy.src.preQuest ~= nil) then
			lib.quest.UpdateByID(Toy.src.preQuest)
		end
		if(Toy.src.requItem ~= nil) then
			lib.item.UpdateByID(Toy.src.requItem)
		end
	end
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	for _,Toy in pairs(Toys) do
		local ToyData = lib.journal.toy.GetByID(Toy.ItemID)
		
		if(ToyData.isCollected) then
			out.StoreCompleted(lib.item.GetByID(Toy.ItemID).Link)
		else
			if(lib.quest.GetByID(Toy.src.FlagQuest).isCompleted) then
				out.StoreDone(lib.item.GetByID(Toy.ItemID).Link)
			else
				local msg = lib.item.GetByID(Toy.ItemID).Link
				msg = msg..lib.tomtom.createLink(Toy.src.MapID, Toy.src.x, Toy.src.y, Toy.src.Name, lib.map.GetNameByID(Toy.src.MapID).." > "..Toy.src.Name)
								
				if(Toy.src.extraInfo ~= nil) then
					msg = msg.." ("..Toy.src.extraInfo..")"
				end
				
				if(Toy.src.requItem ~= nil) then
					msg = msg.." (requires "..lib.item.GetByID(Toy.src.requItem).Link..")"
				end
				
				if(Toy.src.preQuest ~= nil and (not lib.quest.GetByID(Toy.src.preQuest).isCompleted)) then
					msg = msg.." (requires "..lib.quest.GetByID(Toy.src.preQuest).Link..")"
				end
				
				if(Toy.src.WQuest == nil) then
					msg = msg..lib.chat.green(" WQ does not exist")
				elseif (lib.worldquest.IsActive(Toy.src.WQuest)) then
					msg = msg..lib.chat.yellow(" WQ active")
				else
					msg = msg..lib.chat.red(" WQ not active")
				end
				
				out.StoreTodo(msg)
			end
		end
	end
	
	return
end

function this.private.Print()
	this.private.Validate()

	local out = lib.chat.output
	out.PrintModule(this.Name)
	
	return
end

this.private.Text = this.Name
function this.private.Script()
	this.private.Validate()
	
	this.private.Update()
	this.private.Print()
	
	return
end

mod[#mod+1] =
{
	Text = this.private.Text,
	Script = this.private.Script
}
