if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

local lib = ttd2.lib

--this module
ttd2.LegionFishing = {}
local this = ttd2.LegionFishing
this.Name = "LegionFishing"

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	--for some quests, there are several possibilities that do share a name but not an ID
	--for the achievement, we only need one of them
	
	this.private.achievement =
	{
		ID = 10598,
		numCriteriaMissing = 0,
		name = nil,
		link = nil,
		completed = nil
	}
	
	this.private.quests = 
	{
		{id=41270, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41612, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41613, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41279, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41604, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41605, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41268, name=nil, numIndex=5, should="Queen Queenfish"},	--Queen Queenfish
		{id=41265, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41610, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41611, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41244, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41596, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41597, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41243, name=nil, numIndex=11, should="Huge Highmountain Salmon"},	--Huge Highmountain Salmon
		{id=41609, name=nil, numIndex=11, should="Huge Highmountain Salmon"},	--Huge Highmountain Salmon
		{id=41266, name=nil, numIndex=13, should="Raft Fishing"},	--Raft Fishing
		{id=41278, name=nil, numIndex=15, should="Slippery Stormrays"},	--Slippery Stormrays
		{id=41277, name=nil, numIndex=17, should="Work Order: Stormrays"},	--Work Order: Stormrays
		{id=41269, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41600, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41601, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41276, name=nil, numIndex=21, should="Rocket Boot Fishing"},	--Rocket Boot Fishing
		{id=41282, name=nil, numIndex=23, should="Work Order: Runescale Koi"},	--Work Order: Runescale Koi
		{id=41267, name=nil, numIndex=2, should="Work Order: Cursed Queenfish"},	--Work Order: Cursed Queenfish
		{id=41264, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41598, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41599, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41252, name=nil, numIndex=6, should="Wild Northern Barracuda"},	--Wild Northern Barracuda
		{id=41280, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41616, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41617, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41274, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41602, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41603, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41273, name=nil, numIndex=12, should="Buoy Fishing"},	--Buoy Fishing
		{id=41275, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41614, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41615, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41271, name=nil, numIndex=16, should="Cave Fishing"},	--Cave Fishing
		{id=41240, name=nil, numIndex=18, should="Work Order: Highmountain Salmon"},	--Work Order: Highmountain Salmon
		{id=41253, name=nil, numIndex=20, should="Migrating Highmountain Salmon"},	--Migrating Highmountain Salmon
		{id=41272, name=nil, numIndex=22, should="Work Order Mossgill Perch"}, 	--Work Order Mossgill Perch
		{id=41283, name=nil, numIndex=24, should="The Angler Mangler"} 	--The Angler Mangler
	}
	
	lib.achievement.AddByID(this.private.achievement.ID)
	
	this.private.set = true
end

function this.private.Update()
	this.private.Validate()
	
	local WQ = lib.worldquest

	local out = lib.chat.output
	out.ClearBuffer()
	
	lib.achievement.UpdateByID(this.private.achievement.ID)
	
	local Ach = lib.achievement.GetByID(this.private.achievement.ID)

	if(Ach.IsCompletedChar == true) then
		out.StoreCompleted(Ach.Link)
	else
		out.StoreTodo(Ach.Link)
	end
	
	local QuestsActive = 0
	for _,quest in pairs(this.private.quests) do
		if(WQ.IsActive(quest.id)) then
			QuestsActive = QuestsActive+1
			
			local Name = WQ.GetNameByID(quest.id)
			local Completed = Ach.CriteriaByIndex[quest.numIndex].IsCompleted
			
			if(Completed == true) then
				out.StoreCompleted(Name)
			else
				out.StoreTodo(Name)
			end
		end
	end
	
	if(QuestsActive == 0) then
		out.StoreDone("no quests active.")
	end
	
	return
end	

function this.private.Print()
	lib.chat.output.PrintModule(this.Name)
	return
end

this.private.Text = this.Name
function this.private.Script()
	this.private.Init()
	this.private.Update()
	this.private.Print()
	
	return
end

mod[#mod+1] =
{
	Text = this.private.Text,
	Script = this.private.Script
}
